<?php

namespace Bydedi\Container;

/**
 * Class ServiceProvider
 * @package Bydedi\Container
 */
abstract class ServiceProvider
{

    /**
     * The application instance.
     *
     * @var ServiceContainer
     */
    protected $serviceContainer;

    /**
     * Create a new service provider instance.
     *
     * @param  ServiceContainer  $serviceContainer
     * @return ServiceProvider
     */
    public function __construct(ServiceContainer $serviceContainer)
    {
        $this->serviceContainer = $serviceContainer;
    }

    /**
     * Register the service provider.
     *
     * @return void
     */
    abstract public function register();
}
