<?php

namespace Bydedi\Security\Driver;

use Bydedi\Security\Entity\Role;
use Bydedi\Security\Entity\Permission;

/**
 * Interface DriverInterface
 * @package Bydedi\Security\Driver
 */
interface DriverInterface
{

    /**
     * @return \Bydedi\Security\Entity\Role[]
     */
    public function getRoles();

    /**
     * @param Role $role
     * @param Permission $permission
     * @return mixed
     */
    public function addPermission(Role $role, Permission $permission);

    /**
     * @param Role $role
     * @param Permission $permission
     * @return mixed
     */
    public function deletePermission(Role $role, Permission $permission);

    /**
     * @param $permissionCode
     * @return Permission
     */
    public function findPermissionByCode($permissionCode);

    /**
     * @param $roleName
     * @return Role
     */
    public function findRoleByCode($roleName);
}
